"use strict";
(self["webpackChunk_datalayer_jupyter_editor"] = self["webpackChunk_datalayer_jupyter_editor"] || []).push([["vendors-node_modules_jupyterlite_pyodide-kernel_node_modules_jupyterlite_contents_lib_index_js"],{

/***/ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/broadcast.js":
/*!*************************************************************************************************************!*\
  !*** ../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/broadcast.js ***!
  \*************************************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BroadcastChannelWrapper": () => (/* binding */ BroadcastChannelWrapper)
/* harmony export */ });
/* harmony import */ var _drivefs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./drivefs */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/drivefs.js");
/* harmony import */ var _drivecontents__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./drivecontents */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/drivecontents.js");
// Copyright (c) Jupyter Development Team.
// Distributed under the terms of the Modified BSD License.


/** A broadcaster for the ServiceWorker */
class BroadcastChannelWrapper {
    constructor(options) {
        this.isDisposed = false;
        /** Handle a message received on the BroadcastChannel */
        this._onMessage = async (event) => {
            if (!this._channel) {
                return;
            }
            const request = event.data;
            const receiver = request === null || request === void 0 ? void 0 : request.receiver;
            if (receiver !== 'broadcast.ts') {
                // Message is not meant for us
                return;
            }
            const response = await this._driveContentsProcessor.processDriveRequest(request);
            this._channel.postMessage(response);
        };
        this._channel = null;
        this._enabled = false;
        this._contents = options.contents;
        this._driveContentsProcessor = new _drivecontents__WEBPACK_IMPORTED_MODULE_0__.DriveContentsProcessor({
            contentsManager: this._contents,
        });
    }
    get enabled() {
        return this._enabled;
    }
    enable() {
        if (this._channel) {
            console.warn('BroadcastChannel already created and enabled');
            return;
        }
        this._channel = new BroadcastChannel(_drivefs__WEBPACK_IMPORTED_MODULE_1__.DRIVE_API_PATH);
        this._channel.addEventListener('message', this._onMessage);
        this._enabled = true;
    }
    disable() {
        if (this._channel) {
            this._channel.removeEventListener('message', this._onMessage);
            this._channel = null;
        }
        this._enabled = false;
    }
    /** Clean up the broadcaster. */
    dispose() {
        if (this.isDisposed) {
            return;
        }
        this.disable();
        this.isDisposed = true;
    }
}


/***/ }),

/***/ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/contents.js":
/*!************************************************************************************************************!*\
  !*** ../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/contents.js ***!
  \************************************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Contents": () => (/* binding */ Contents)
/* harmony export */ });
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/coreutils */ "webpack/sharing/consume/default/@jupyterlab/coreutils");
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _tokens__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./tokens */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/tokens.js");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__);




/**
 * The name of the local storage.
 */
const DEFAULT_STORAGE_NAME = 'JupyterLite Storage';
/**
 * The number of checkpoints to save.
 */
const N_CHECKPOINTS = 5;
const encoder = new TextEncoder();
const decoder = new TextDecoder('utf-8');
/**
 * A class to handle requests to /api/contents
 */
class Contents {
    /**
     * Construct a new localForage-powered contents provider
     */
    constructor(options) {
        /**
         * A reducer for turning arbitrary binary into a string
         */
        this.reduceBytesToString = (data, byte) => {
            return data + String.fromCharCode(byte);
        };
        this._serverContents = new Map();
        this._storageName = DEFAULT_STORAGE_NAME;
        this._storageDrivers = null;
        this._localforage = options.localforage;
        this._storageName = options.storageName || DEFAULT_STORAGE_NAME;
        this._storageDrivers = options.storageDrivers || null;
        this._ready = new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.PromiseDelegate();
    }
    /**
     * Finish any initialization after server has started and all extensions are applied.
     */
    async initialize() {
        await this.initStorage();
        this._ready.resolve(void 0);
    }
    /**
     * Initialize all storage instances
     */
    async initStorage() {
        this._storage = this.createDefaultStorage();
        this._counters = this.createDefaultCounters();
        this._checkpoints = this.createDefaultCheckpoints();
    }
    /**
     * A promise that resolves once all storage is fully initialized.
     */
    get ready() {
        return this._ready.promise;
    }
    /**
     * A lazy reference to the underlying storage.
     */
    get storage() {
        return this.ready.then(() => this._storage);
    }
    /**
     * A lazy reference to the underlying counters.
     */
    get counters() {
        return this.ready.then(() => this._counters);
    }
    /**
     * A lazy reference to the underlying checkpoints.
     */
    get checkpoints() {
        return this.ready.then(() => this._checkpoints);
    }
    /**
     * Get default options for localForage instances
     */
    get defaultStorageOptions() {
        const driver = this._storageDrivers && this._storageDrivers.length ? this._storageDrivers : null;
        return {
            version: 1,
            name: this._storageName,
            ...(driver ? { driver } : {}),
        };
    }
    /**
     * Initialize the default storage for contents.
     */
    createDefaultStorage() {
        return this._localforage.createInstance({
            description: 'Offline Storage for Notebooks and Files',
            storeName: 'files',
            ...this.defaultStorageOptions,
        });
    }
    /**
     * Initialize the default storage for counting file suffixes.
     */
    createDefaultCounters() {
        return this._localforage.createInstance({
            description: 'Store the current file suffix counters',
            storeName: 'counters',
            ...this.defaultStorageOptions,
        });
    }
    /**
     * Create the default checkpoint storage.
     */
    createDefaultCheckpoints() {
        return this._localforage.createInstance({
            description: 'Offline Storage for Checkpoints',
            storeName: 'checkpoints',
            ...this.defaultStorageOptions,
        });
    }
    /**
     * Create a new untitled file or directory in the specified directory path.
     *
     * @param options: The options used to create the file.
     *
     * @returns A promise which resolves with the created file content when the file is created.
     */
    async newUntitled(options) {
        var _a, _b, _c;
        const path = (_a = options === null || options === void 0 ? void 0 : options.path) !== null && _a !== void 0 ? _a : '';
        const type = (_b = options === null || options === void 0 ? void 0 : options.type) !== null && _b !== void 0 ? _b : 'notebook';
        const created = new Date().toISOString();
        let dirname = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.dirname(path);
        const basename = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.basename(path);
        const extname = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.extname(path);
        const item = await this.get(dirname);
        // handle the case of "Save As", where the path points to the new file
        // to create, e.g. subfolder/example-copy.ipynb
        let name = '';
        if (path && !extname && item) {
            // directory
            dirname = `${path}/`;
            name = '';
        }
        else if (dirname && basename) {
            // file in a subfolder
            dirname = `${dirname}/`;
            name = basename;
        }
        else {
            // file at the top level
            dirname = '';
            name = path;
        }
        let file;
        switch (type) {
            case 'directory': {
                const counter = await this._incrementCounter('directory');
                name = `Untitled Folder${counter || ''}`;
                file = {
                    name,
                    path: `${dirname}${name}`,
                    last_modified: created,
                    created,
                    format: 'json',
                    mimetype: '',
                    content: null,
                    size: 0,
                    writable: true,
                    type: 'directory',
                };
                break;
            }
            case 'notebook': {
                const counter = await this._incrementCounter('notebook');
                name = name || `Untitled${counter || ''}.ipynb`;
                file = {
                    name,
                    path: `${dirname}${name}`,
                    last_modified: created,
                    created,
                    format: 'json',
                    mimetype: _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME.JSON,
                    content: Private.EMPTY_NB,
                    size: encoder.encode(JSON.stringify(Private.EMPTY_NB)).length,
                    writable: true,
                    type: 'notebook',
                };
                break;
            }
            default: {
                const ext = (_c = options === null || options === void 0 ? void 0 : options.ext) !== null && _c !== void 0 ? _c : '.txt';
                const counter = await this._incrementCounter('file');
                const mimetype = _tokens__WEBPACK_IMPORTED_MODULE_2__.FILE.getType(ext) || _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME.OCTET_STREAM;
                let format;
                if (_tokens__WEBPACK_IMPORTED_MODULE_2__.FILE.hasFormat(ext, 'text') || mimetype.indexOf('text') !== -1) {
                    format = 'text';
                }
                else if (ext.indexOf('json') !== -1 || ext.indexOf('ipynb') !== -1) {
                    format = 'json';
                }
                else {
                    format = 'base64';
                }
                name = name || `untitled${counter || ''}${ext}`;
                file = {
                    name,
                    path: `${dirname}${name}`,
                    last_modified: created,
                    created,
                    format,
                    mimetype,
                    content: '',
                    size: 0,
                    writable: true,
                    type: 'file',
                };
                break;
            }
        }
        const key = file.path;
        await (await this.storage).setItem(key, file);
        return file;
    }
    /**
     * Copy a file into a given directory.
     *
     * @param path - The original file path.
     * @param toDir - The destination directory path.
     *
     * @returns A promise which resolves with the new contents model when the
     *  file is copied.
     *
     * #### Notes
     * The server will select the name of the copied file.
     */
    async copy(path, toDir) {
        let name = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.basename(path);
        toDir = toDir === '' ? '' : `${_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.removeSlash(toDir)}/`;
        // TODO: better handle naming collisions with existing files
        while (await this.get(`${toDir}${name}`, { content: true })) {
            const ext = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.extname(name);
            const base = name.replace(ext, '');
            name = `${base} (copy)${ext}`;
        }
        const toPath = `${toDir}${name}`;
        let item = await this.get(path, { content: true });
        if (!item) {
            throw Error(`Could not find file with path ${path}`);
        }
        item = {
            ...item,
            name,
            path: toPath,
        };
        await (await this.storage).setItem(toPath, item);
        return item;
    }
    /**
     * Get a file or directory.
     *
     * @param path: The path to the file.
     * @param options: The options used to fetch the file.
     *
     * @returns A promise which resolves with the file content.
     */
    async get(path, options) {
        // remove leading slash
        path = decodeURIComponent(path.replace(/^\//, ''));
        if (path === '') {
            return await this._getFolder(path);
        }
        const storage = await this.storage;
        const item = await storage.getItem(path);
        const serverItem = await this._getServerContents(path, options);
        const model = (item || serverItem);
        if (!model) {
            return null;
        }
        if (!(options === null || options === void 0 ? void 0 : options.content)) {
            return {
                size: 0,
                ...model,
                content: null,
            };
        }
        // for directories, find all files with the path as the prefix
        if (model.type === 'directory') {
            const contentMap = new Map();
            await storage.iterate((file, key) => {
                // use an additional slash to not include the directory itself
                if (key === `${path}/${file.name}`) {
                    contentMap.set(file.name, file);
                }
            });
            const serverContents = serverItem
                ? serverItem.content
                : Array.from((await this._getServerDirectory(path)).values());
            for (const file of serverContents) {
                if (!contentMap.has(file.name)) {
                    contentMap.set(file.name, file);
                }
            }
            const content = [...contentMap.values()];
            return {
                name: _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.basename(path),
                path,
                last_modified: model.last_modified,
                created: model.created,
                format: 'json',
                mimetype: _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME.JSON,
                content,
                size: 0,
                writable: true,
                type: 'directory',
            };
        }
        return model;
    }
    /**
     * Rename a file or directory.
     *
     * @param oldLocalPath - The original file path.
     * @param newLocalPath - The new file path.
     *
     * @returns A promise which resolves with the new file content model when the file is renamed.
     */
    async rename(oldLocalPath, newLocalPath) {
        const path = decodeURIComponent(oldLocalPath);
        const file = await this.get(path, { content: true });
        if (!file) {
            throw Error(`Could not find file with path ${path}`);
        }
        const modified = new Date().toISOString();
        const name = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.basename(newLocalPath);
        const newFile = {
            ...file,
            name,
            path: newLocalPath,
            last_modified: modified,
        };
        const storage = await this.storage;
        await storage.setItem(newLocalPath, newFile);
        // remove the old file
        await storage.removeItem(path);
        // remove the corresponding checkpoint
        await (await this.checkpoints).removeItem(path);
        // if a directory, recurse through all children
        if (file.type === 'directory') {
            let child;
            for (child of file.content) {
                await this.rename(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.URLExt.join(oldLocalPath, child.name), _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.URLExt.join(newLocalPath, child.name));
            }
        }
        return newFile;
    }
    /**
     * Save a file.
     *
     * @param path - The desired file path.
     * @param options - Optional overrides to the model.
     *
     * @returns A promise which resolves with the file content model when the file is saved.
     */
    async save(path, options = {}) {
        var _a;
        path = decodeURIComponent(path);
        // process the file if coming from an upload
        const ext = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.extname((_a = options.name) !== null && _a !== void 0 ? _a : '');
        const chunk = options.chunk;
        // retrieve the content if it is a later chunk or the last one
        // the new content will then be appended to the existing one
        const appendChunk = chunk ? chunk > 1 || chunk === -1 : false;
        let item = await this.get(path, { content: appendChunk });
        if (!item) {
            item = await this.newUntitled({ path, ext, type: 'file' });
        }
        if (!item) {
            return null;
        }
        // keep a reference to the original content
        const originalContent = item.content;
        const modified = new Date().toISOString();
        // override with the new values
        item = {
            ...item,
            ...options,
            last_modified: modified,
        };
        if (options.content && options.format === 'base64') {
            const lastChunk = chunk ? chunk === -1 : true;
            const contentBinaryString = this._handleUploadChunk(options.content, originalContent, appendChunk);
            if (ext === '.ipynb') {
                const content = lastChunk
                    ? JSON.parse(decoder.decode(this._binaryStringToBytes(contentBinaryString)))
                    : contentBinaryString;
                item = {
                    ...item,
                    content,
                    format: 'json',
                    type: 'notebook',
                    size: contentBinaryString.length,
                };
            }
            else if (_tokens__WEBPACK_IMPORTED_MODULE_2__.FILE.hasFormat(ext, 'json')) {
                const content = lastChunk
                    ? JSON.parse(decoder.decode(this._binaryStringToBytes(contentBinaryString)))
                    : contentBinaryString;
                item = {
                    ...item,
                    content,
                    format: 'json',
                    type: 'file',
                    size: contentBinaryString.length,
                };
            }
            else if (_tokens__WEBPACK_IMPORTED_MODULE_2__.FILE.hasFormat(ext, 'text')) {
                const content = lastChunk
                    ? decoder.decode(this._binaryStringToBytes(contentBinaryString))
                    : contentBinaryString;
                item = {
                    ...item,
                    content,
                    format: 'text',
                    type: 'file',
                    size: contentBinaryString.length,
                };
            }
            else {
                const content = lastChunk ? btoa(contentBinaryString) : contentBinaryString;
                item = {
                    ...item,
                    content,
                    format: 'base64',
                    type: 'file',
                    size: contentBinaryString.length,
                };
            }
        }
        // fixup content sizes if necessary
        if (item.content) {
            switch (options.format) {
                case 'json': {
                    item = { ...item, size: encoder.encode(JSON.stringify(item.content)).length };
                    break;
                }
                case 'text': {
                    item = { ...item, size: encoder.encode(item.content).length };
                    break;
                }
                // base64 save was already handled above
                case 'base64': {
                    break;
                }
                default: {
                    item = { ...item, size: 0 };
                    break;
                }
            }
        }
        else {
            item = { ...item, size: 0 };
        }
        await (await this.storage).setItem(path, item);
        return item;
    }
    /**
     * Delete a file from browser storage.
     *
     * Has no effect on server-backed files, which will re-appear with their
     * original timestamp.
     *
     * @param path - The path to the file.
     */
    async delete(path) {
        path = decodeURIComponent(path);
        const slashed = `${path}/`;
        const toDelete = (await (await this.storage).keys()).filter((key) => key === path || key.startsWith(slashed));
        await Promise.all(toDelete.map(this.forgetPath, this));
    }
    /**
     * Remove the localForage and checkpoints for a path.
     *
     * @param path - The path to the file
     */
    async forgetPath(path) {
        await Promise.all([
            (await this.storage).removeItem(path),
            (await this.checkpoints).removeItem(path),
        ]);
    }
    /**
     * Create a checkpoint for a file.
     *
     * @param path - The path of the file.
     *
     * @returns A promise which resolves with the new checkpoint model when the
     *   checkpoint is created.
     */
    async createCheckpoint(path) {
        var _a;
        const checkpoints = await this.checkpoints;
        path = decodeURIComponent(path);
        const item = await this.get(path, { content: true });
        if (!item) {
            throw Error(`Could not find file with path ${path}`);
        }
        const copies = ((_a = (await checkpoints.getItem(path))) !== null && _a !== void 0 ? _a : []).filter(Boolean);
        copies.push(item);
        // keep only a certain amount of checkpoints per file
        if (copies.length > N_CHECKPOINTS) {
            copies.splice(0, copies.length - N_CHECKPOINTS);
        }
        await checkpoints.setItem(path, copies);
        const id = `${copies.length - 1}`;
        return { id, last_modified: item.last_modified };
    }
    /**
     * List available checkpoints for a file.
     *
     * @param path - The path of the file.
     *
     * @returns A promise which resolves with a list of checkpoint models for
     *    the file.
     */
    async listCheckpoints(path) {
        const copies = (await (await this.checkpoints).getItem(path)) || [];
        return copies.filter(Boolean).map(this.normalizeCheckpoint, this);
    }
    normalizeCheckpoint(model, id) {
        return { id: id.toString(), last_modified: model.last_modified };
    }
    /**
     * Restore a file to a known checkpoint state.
     *
     * @param path - The path of the file.
     * @param checkpointID - The id of the checkpoint to restore.
     *
     * @returns A promise which resolves when the checkpoint is restored.
     */
    async restoreCheckpoint(path, checkpointID) {
        path = decodeURIComponent(path);
        const copies = ((await (await this.checkpoints).getItem(path)) || []);
        const id = parseInt(checkpointID);
        const item = copies[id];
        await (await this.storage).setItem(path, item);
    }
    /**
     * Delete a checkpoint for a file.
     *
     * @param path - The path of the file.
     * @param checkpointID - The id of the checkpoint to delete.
     *
     * @returns A promise which resolves when the checkpoint is deleted.
     */
    async deleteCheckpoint(path, checkpointID) {
        path = decodeURIComponent(path);
        const copies = ((await (await this.checkpoints).getItem(path)) || []);
        const id = parseInt(checkpointID);
        copies.splice(id, 1);
        await (await this.checkpoints).setItem(path, copies);
    }
    /**
     * Handle an upload chunk for a file.
     * each chunk is base64 encoded, so we need to decode it and append it to the
     * original content.
     * @param newContent the new content to process, base64 encoded
     * @param originalContent the original content, must be null or a binary string if chunked is true
     * @param appendChunk whether the chunk should be appended to the originalContent
     *
     *
     * @returns the decoded binary string, appended to the original content if requested
     * /
     */
    _handleUploadChunk(newContent, originalContent, appendChunk) {
        const newContentBinaryString = atob(newContent);
        const contentBinaryString = appendChunk
            ? originalContent + newContentBinaryString
            : newContentBinaryString;
        return contentBinaryString;
    }
    /**
     * Convert a binary string to an Uint8Array
     * @param binaryString the binary string
     * @returns the bytes of the binary string
     */
    _binaryStringToBytes(binaryString) {
        const bytes = new Uint8Array(binaryString.length);
        for (let i = 0; i < binaryString.length; i++) {
            bytes[i] = binaryString.charCodeAt(i);
        }
        return bytes;
    }
    /**
     * retrieve the contents for this path from the union of local storage and
     * `api/contents/{path}/all.json`.
     *
     * @param path - The contents path to retrieve
     *
     * @returns A promise which resolves with a Map of contents, keyed by local file name
     */
    async _getFolder(path) {
        const content = new Map();
        const storage = await this.storage;
        await storage.iterate((file, key) => {
            if (key.includes('/')) {
                return;
            }
            content.set(file.path, file);
        });
        // layer in contents that don't have local overwrites
        for (const file of (await this._getServerDirectory(path)).values()) {
            if (!content.has(file.path)) {
                content.set(file.path, file);
            }
        }
        if (path && content.size === 0) {
            return null;
        }
        return {
            name: '',
            path,
            last_modified: new Date(0).toISOString(),
            created: new Date(0).toISOString(),
            format: 'json',
            mimetype: _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME.JSON,
            content: Array.from(content.values()),
            size: 0,
            writable: true,
            type: 'directory',
        };
    }
    /**
     * Attempt to recover the model from `{:path}/__all__.json` file, fall back to
     * deriving the model (including content) off the file in `/files/`. Otherwise
     * return `null`.
     */
    async _getServerContents(path, options) {
        const name = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.basename(path);
        const parentContents = await this._getServerDirectory(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.URLExt.join(path, '..'));
        let model = parentContents.get(name);
        if (!model) {
            return null;
        }
        model = model || {
            name,
            path,
            last_modified: new Date(0).toISOString(),
            created: new Date(0).toISOString(),
            format: 'text',
            mimetype: _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME.PLAIN_TEXT,
            type: 'file',
            writable: true,
            size: 0,
            content: '',
        };
        if (options === null || options === void 0 ? void 0 : options.content) {
            if (model.type === 'directory') {
                const serverContents = await this._getServerDirectory(path);
                model = { ...model, content: Array.from(serverContents.values()) };
            }
            else {
                const fileUrl = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.URLExt.join(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.getBaseUrl(), 'files', path);
                const response = await fetch(fileUrl);
                if (!response.ok) {
                    return null;
                }
                const mimetype = model.mimetype || response.headers.get('Content-Type');
                const ext = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PathExt.extname(name);
                if (model.type === 'notebook' ||
                    _tokens__WEBPACK_IMPORTED_MODULE_2__.FILE.hasFormat(ext, 'json') ||
                    (mimetype === null || mimetype === void 0 ? void 0 : mimetype.indexOf('json')) !== -1 ||
                    path.match(/\.(ipynb|[^/]*json[^/]*)$/)) {
                    const contentText = await response.text();
                    model = {
                        ...model,
                        content: JSON.parse(contentText),
                        format: 'json',
                        mimetype: model.mimetype || _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME.JSON,
                        size: encoder.encode(contentText).length,
                    };
                }
                else if (_tokens__WEBPACK_IMPORTED_MODULE_2__.FILE.hasFormat(ext, 'text') || mimetype.indexOf('text') !== -1) {
                    const contentText = await response.text();
                    model = {
                        ...model,
                        content: contentText,
                        format: 'text',
                        mimetype: mimetype || _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME.PLAIN_TEXT,
                        size: encoder.encode(contentText).length,
                    };
                }
                else {
                    const contentBuffer = await response.arrayBuffer();
                    const contentBytes = new Uint8Array(contentBuffer);
                    model = {
                        ...model,
                        content: btoa(contentBytes.reduce(this.reduceBytesToString, '')),
                        format: 'base64',
                        mimetype: mimetype || _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME.OCTET_STREAM,
                        size: contentBytes.length,
                    };
                }
            }
        }
        return model;
    }
    /**
     * retrieve the contents for this path from `__index__.json` in the appropriate
     * folder.
     *
     * @param newLocalPath - The new file path.
     *
     * @returns A promise which resolves with a Map of contents, keyed by local file name
     */
    async _getServerDirectory(path) {
        const content = this._serverContents.get(path) || new Map();
        if (!this._serverContents.has(path)) {
            const apiURL = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.URLExt.join(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.getBaseUrl(), 'api/contents', path, 'all.json');
            try {
                const response = await fetch(apiURL);
                const json = JSON.parse(await response.text());
                for (const file of json['content']) {
                    content.set(file.name, file);
                }
            }
            catch (err) {
                console.warn(`don't worry, about ${err}... nothing's broken. If there had been a
          file at ${apiURL}, you might see some more files.`);
            }
            this._serverContents.set(path, content);
        }
        return content;
    }
    /**
     * Increment the counter for a given file type.
     * Used to avoid collisions when creating new untitled files.
     *
     * @param type The file type to increment the counter for.
     */
    async _incrementCounter(type) {
        var _a;
        const counters = await this.counters;
        const current = (_a = (await counters.getItem(type))) !== null && _a !== void 0 ? _a : -1;
        const counter = current + 1;
        await counters.setItem(type, counter);
        return counter;
    }
}
/**
 * A namespace for private data.
 */
var Private;
(function (Private) {
    /**
     * The content for an empty notebook.
     */
    Private.EMPTY_NB = {
        metadata: {
            orig_nbformat: 4,
        },
        nbformat_minor: 4,
        nbformat: 4,
        cells: [],
    };
})(Private || (Private = {}));


/***/ }),

/***/ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/index.js":
/*!*********************************************************************************************************!*\
  !*** ../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/index.js ***!
  \*********************************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BLOCK_SIZE": () => (/* reexport safe */ _drivefs__WEBPACK_IMPORTED_MODULE_1__.BLOCK_SIZE),
/* harmony export */   "BroadcastChannelWrapper": () => (/* reexport safe */ _broadcast__WEBPACK_IMPORTED_MODULE_3__.BroadcastChannelWrapper),
/* harmony export */   "Contents": () => (/* reexport safe */ _contents__WEBPACK_IMPORTED_MODULE_0__.Contents),
/* harmony export */   "ContentsAPI": () => (/* reexport safe */ _drivefs__WEBPACK_IMPORTED_MODULE_1__.ContentsAPI),
/* harmony export */   "DIR_MODE": () => (/* reexport safe */ _emscripten__WEBPACK_IMPORTED_MODULE_4__.DIR_MODE),
/* harmony export */   "DRIVE_API_PATH": () => (/* reexport safe */ _drivefs__WEBPACK_IMPORTED_MODULE_1__.DRIVE_API_PATH),
/* harmony export */   "DRIVE_SEPARATOR": () => (/* reexport safe */ _drivefs__WEBPACK_IMPORTED_MODULE_1__.DRIVE_SEPARATOR),
/* harmony export */   "DriveContentsProcessor": () => (/* reexport safe */ _drivecontents__WEBPACK_IMPORTED_MODULE_5__.DriveContentsProcessor),
/* harmony export */   "DriveFS": () => (/* reexport safe */ _drivefs__WEBPACK_IMPORTED_MODULE_1__.DriveFS),
/* harmony export */   "DriveFSEmscriptenNodeOps": () => (/* reexport safe */ _drivefs__WEBPACK_IMPORTED_MODULE_1__.DriveFSEmscriptenNodeOps),
/* harmony export */   "DriveFSEmscriptenStreamOps": () => (/* reexport safe */ _drivefs__WEBPACK_IMPORTED_MODULE_1__.DriveFSEmscriptenStreamOps),
/* harmony export */   "FILE": () => (/* reexport safe */ _tokens__WEBPACK_IMPORTED_MODULE_2__.FILE),
/* harmony export */   "FILE_MODE": () => (/* reexport safe */ _emscripten__WEBPACK_IMPORTED_MODULE_4__.FILE_MODE),
/* harmony export */   "IBroadcastChannelWrapper": () => (/* reexport safe */ _tokens__WEBPACK_IMPORTED_MODULE_2__.IBroadcastChannelWrapper),
/* harmony export */   "IContents": () => (/* reexport safe */ _tokens__WEBPACK_IMPORTED_MODULE_2__.IContents),
/* harmony export */   "MIME": () => (/* reexport safe */ _tokens__WEBPACK_IMPORTED_MODULE_2__.MIME),
/* harmony export */   "SEEK_CUR": () => (/* reexport safe */ _emscripten__WEBPACK_IMPORTED_MODULE_4__.SEEK_CUR),
/* harmony export */   "SEEK_END": () => (/* reexport safe */ _emscripten__WEBPACK_IMPORTED_MODULE_4__.SEEK_END),
/* harmony export */   "ServiceWorkerContentsAPI": () => (/* reexport safe */ _drivefs__WEBPACK_IMPORTED_MODULE_1__.ServiceWorkerContentsAPI),
/* harmony export */   "instanceOfStream": () => (/* reexport safe */ _emscripten__WEBPACK_IMPORTED_MODULE_4__.instanceOfStream)
/* harmony export */ });
/* harmony import */ var _contents__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./contents */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/contents.js");
/* harmony import */ var _drivefs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./drivefs */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/drivefs.js");
/* harmony import */ var _tokens__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./tokens */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/tokens.js");
/* harmony import */ var _broadcast__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./broadcast */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/broadcast.js");
/* harmony import */ var _emscripten__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./emscripten */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/emscripten.js");
/* harmony import */ var _drivecontents__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./drivecontents */ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/drivecontents.js");
// Copyright (c) Jupyter Development Team.
// Distributed under the terms of the Modified BSD License.








/***/ }),

/***/ "../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/tokens.js":
/*!**********************************************************************************************************!*\
  !*** ../../../node_modules/@jupyterlite/pyodide-kernel/node_modules/@jupyterlite/contents/lib/tokens.js ***!
  \**********************************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FILE": () => (/* binding */ FILE),
/* harmony export */   "IBroadcastChannelWrapper": () => (/* binding */ IBroadcastChannelWrapper),
/* harmony export */   "IContents": () => (/* binding */ IContents),
/* harmony export */   "MIME": () => (/* binding */ MIME)
/* harmony export */ });
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/coreutils */ "webpack/sharing/consume/default/@jupyterlab/coreutils");
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var mime__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! mime */ "../../../node_modules/mime/index.js");
/* harmony import */ var mime__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(mime__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__);



/**
 * The token for the settings service.
 */
const IContents = new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__.Token('@jupyterlite/contents:IContents');
/**
 * Commonly-used mimetypes
 */
var MIME;
(function (MIME) {
    MIME.JSON = 'application/json';
    MIME.PLAIN_TEXT = 'text/plain';
    MIME.OCTET_STREAM = 'octet/stream';
})(MIME || (MIME = {}));
/**
 * A namespace for file constructs.
 */
var FILE;
(function (FILE) {
    /**
     * Build-time configured file types.
     */
    const TYPES = JSON.parse(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.getOption('fileTypes') || '{}');
    /**
     * Get a mimetype (or fallback).
     */
    function getType(ext, defaultType = null) {
        ext = ext.toLowerCase();
        for (const fileType of Object.values(TYPES)) {
            for (const fileExt of fileType.extensions || []) {
                if (fileExt === ext && fileType.mimeTypes && fileType.mimeTypes.length) {
                    return fileType.mimeTypes[0];
                }
            }
        }
        return mime__WEBPACK_IMPORTED_MODULE_1___default().getType(ext) || defaultType || MIME.OCTET_STREAM;
    }
    FILE.getType = getType;
    /**
     * Determine whether the given extension matches a given fileFormat.
     */
    function hasFormat(ext, fileFormat) {
        ext = ext.toLowerCase();
        for (const fileType of Object.values(TYPES)) {
            if (fileType.fileFormat !== fileFormat) {
                continue;
            }
            for (const fileExt of fileType.extensions || []) {
                if (fileExt === ext) {
                    return true;
                }
            }
        }
        return false;
    }
    FILE.hasFormat = hasFormat;
})(FILE || (FILE = {}));
/**
 * The token for the BroadcastChannel broadcaster.
 */
const IBroadcastChannelWrapper = new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__.Token('@jupyterlite/contents:IBroadcastChannelWrapper');


/***/ })

}]);
//# sourceMappingURL=vendors-node_modules_jupyterlite_pyodide-kernel_node_modules_jupyterlite_contents_lib_index_js.55aea83408e8c71690bf.js.map